#ifndef __DRIVERS_H
#define __DRIVERS_H

#include <common/types.h>

class Driver;
class DriversManager;

class Driver{
public:
    Driver();
    ~Driver();

    virtual void Activate();
    virtual void Reset();
    virtual void DeActivate();
};

class DriversManager{
private:
    Driver* drivers[256];
    uint8_t drivers_num;

public:
    DriversManager();
    ~DriversManager();

    void AddDrivers(Driver* drv);
    void AllActivate();
    void AllDeActivate();
};

#endif