#ifndef __KEY_BOARD_H
#define __KEY_BOARD_H

#include <common/types.h>
#include <hardwarecommunication/interrupts.h>
#include <hardwarecommunication/port.h>
#include <drivers/drivers.h>

class KeyBoardDriver : public InterruptHandler, public Driver  {
public:
    KeyBoardDriver(InterruptManager* manager);
    ~KeyBoardDriver();
    virtual uint32_t HandleInterrupt(uint32_t esp);

    virtual void Activate();
    virtual void Reset();
    virtual void DeActivate();

private:
    Port8Bit dataport;
    Port8Bit commandport;
};

#endif 