#include <common/scream.h>

uint8_t Scream::x = 0;
uint8_t Scream::y = 0;
bool Scream::flag = false;
uint16_t* Scream::VideoMemory = (uint16_t*) 0xb8000;

Scream::Scream(){
    if(!flag){
        flag = true;
        draw(x, y);
        puts("[INFO] Scraem Loaded.\n");
    }
    return;
}

Scream::~Scream(){
    return;
}

void Scream::put(const char ch){
    draw(x, y);
    switch(ch) {
        case '\n':
            y++;
            x = 0;
            break;
        default:
            VideoMemory[80 * y + x] = (VideoMemory[80 * y + x] & 0xFF00) | ch;
            x++;
            break;
    }
        
    if (x >= 80) {
        x = 0;
        y++;
    }

    if (y >= 25) {
        for(int pos = 0; pos < 2000; pos ++){
            if(pos < 1920)
                VideoMemory[pos] = VideoMemory[pos + 80];
            else
                VideoMemory[pos] = (VideoMemory[pos] & 0xFF00) | ' ';
        }
        x = 0, y = 24;
    }
        
    draw(x, y);
    return;
}
 
void Scream::puts(const char* str){
    for (int i = 0; str[i]; i++) {
        if(str[i] != '\0')
            put(str[i]);
    }

    return;
}

void Scream::delchar(){
    if(x <= 0)
        return;
    draw(x, y);
    x --;
    VideoMemory[x + y * 80] = (VideoMemory[x + y * 80] & 0xFF00) | ' ';
    draw(x, y);
    return;
}

void Scream::draw(uint8_t xp, uint8_t yp){
    int pos = xp + yp * 80;
    VideoMemory[pos] = ((VideoMemory[pos] & 0xf000) >> 4) | ((VideoMemory[pos] & 0x0f00) << 4) | (VideoMemory[pos] & 0x00ff);
    return;
};